#include <iostream>

using namespace std;

int main()
{
    int n, brojo, broja, brojb, brojab, potrebnezao = 0,potrebnezaa = 0,potrebnezab = 0, potrebnezaab = 0;
    cin >> n;
    cin >> brojo>>broja>>brojb>>brojab;
    string krvnegrupe[n];
    
    int brojkrvnegrupe[n];
    for (int i = 0; i<n; i++)
    {
        cin >> krvnegrupe[i]>>brojkrvnegrupe[i];
        if (krvnegrupe[i]== "O")
            potrebnezao += brojkrvnegrupe[i];
        else if (krvnegrupe[i]== "A")
            potrebnezaa += brojkrvnegrupe[i];
        else if (krvnegrupe[i]== "B")
            potrebnezab+= brojkrvnegrupe[i];
        else if(krvnegrupe[i]=="AB")
            potrebnezaab += brojkrvnegrupe[i];
    }
    if (brojo < potrebnezao)
        cout<<"nemoguce"<<endl;
    else
    {
        brojo = brojo-potrebnezao;
        if (broja < potrebnezaa)
        {
            if (broja+brojo<potrebnezaa)
                cout << "nemoguce"<<endl;
            else
            {
                brojo = brojo+broja-potrebnezaa;
                broja = 0;
                if (brojb < potrebnezab)
                {
                    if (brojb+brojo<potrebnezab)
                        cout << "nemoguce"<<endl;
                    else
                    {
                        brojo = brojo+brojb-potrebnezab;
                        brojb = 0;
                        if (brojab<potrebnezaab)
                        {
                            if(brojab+broja+brojb+brojo < potrebnezaab)
                                cout<<"nemoguce";
                            else
                            {
                                cout << "moguce"<<endl;
                                //racunanje
                            }
                        }
                        else
                        {
                            cout << "moguce"<<endl;
                            //racunanje
                        }
                    }
                }
                else
                {
                    brojb = brojb-potrebnezab;
                        if (brojab<potrebnezaab)
                        {
                            if(brojab+broja+brojb+brojo < potrebnezaab)
                                cout<<"nemoguce";
                            else
                            {
                                cout << "moguce"<<endl;
                                //racunanje
                            }
                        }
                        else
                        {
                            cout << "moguce"<<endl;
                            //racunanje
                        }

                }
            }
        }
        else
        {
            broja = broja-potrebnezaa;
            if (brojb < potrebnezab)
                {
                    if (brojb+brojo<potrebnezab)
                        cout << "nemoguce"<<endl;
                    else
                    {
                        brojo = brojo+brojb-potrebnezab;
                        brojb = 0;
                        if (brojab<potrebnezaab)
                        {
                            if(brojab+broja+brojb+brojo < potrebnezaab)
                                cout<<"nemoguce";
                            else
                            {
                                cout << "moguce"<<endl;
                                //racunanje
                            }
                        }
                        else
                        {
                            cout << "moguce"<<endl;
                            //racunanje
                        }
                    }
                }
                else
                {
                    brojb = brojb-potrebnezab;
                        if (brojab<potrebnezaab)
                        {
                            if(brojab+broja+brojb+brojo < potrebnezaab)
                                cout<<"nemoguce";
                            else
                            {
                                cout << "moguce"<<endl;
                                //racunanje
                            }
                        }
                        else
                        {
                            cout << "moguce"<<endl;
                            //racunanje
                        }
                    }

        }
    }

}